/*
 * Crypto testing [1]
 *
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Authors:	Catalin(ux aka Dino) BOIE, <catab at deuroconsult.ro>
 */

#include <linux/config.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/sched.h>
#include <linux/smp_lock.h>
#include <linux/capability.h>
#include <linux/in.h>
#include <linux/ip.h>
#include <linux/udp.h>
#include <linux/tcp.h>
#include <linux/time.h>

#include <linux/proc_fs.h>
#include <asm/uaccess.h>

#include <linux/string.h>
#include <linux/netdevice.h>
#include <net/pkt_sched.h>

/* crypto stuff */
#include <asm/scatterlist.h>
#include <linux/crypto.h>


#define MODULE_NAME "crypto1 v0.1"

#if 1
#define DPRINTK(format,args...)	printk(KERN_DEBUG MODULE_NAME ": " format, ##args)
#else
#define DPRINTK(format,args...)
#endif


/* global variables */

/* Functions */
static void crypto1_md5 (char *str, int len)
{
	struct crypto_tfm	*tfm;
	char			ret [64];
	int			i, size;
	struct scatterlist	sg [8];

	tfm = crypto_alloc_tfm("md5", 0);
	if (tfm ==NULL) {
		DPRINTK("Failed to load transform!\n");
		return;
	}

	crypto_digest_init(tfm);

	/* prepare sg */
	sg[0].page = virt_to_page(str);
	sg[0].offset = offset_in_page(str);
	sg[0].length = len;

	crypto_digest_update(tfm, sg, 1);
	crypto_digest_final(tfm, ret);

	size = crypto_tfm_alg_digestsize(tfm);
	DPRINTK("size=%d\n", size);

	DPRINTK("Ret: ");
	for (i = 0; i < size; i ++)
		printk("%02x", ret [i] & 0xff);
	printk(KERN_DEBUG "\n");
}

static int __init init_crypto1(void)
{
	printk(KERN_DEBUG "%s: (C)opyright Catalin(ux) BOIE 2004-\n",
	       MODULE_NAME);

	crypto1_md5 ("aaa", 3);

	return -ENOMEM;
}

static void __exit exit_crypto1(void)
{
	printk(KERN_DEBUG "%s: Goodbye!\n", MODULE_NAME);
}

module_init(init_crypto1);
module_exit(exit_crypto1);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Catalin(ux) BOIE - <catab at deuroconsult.ro>");
MODULE_DESCRIPTION("crypto1 - Test crypto [1]");
